#!/usr/local/bin/env python3
#prog 04_03 (comparators.py)

import time

class Comparator:                    
    def __init__(self, setpoint):
        self.switch_level = setpoint
        self.output = False
    
    def switching(self, voltage):
        if voltage > self.switch_level:
            self.output = True
        else:
            self.output = False         

class SchmittTrigger(Comparator):
    def __init__(self, setpoint, hysteresis):
        Comparator.__init__(self, setpoint)      #this is needed because the inherited __init__ has been
        self.hyst= hysteresis	                 #superceded by the preceding line.        
                
    def trigger(self, voltage):
        if self.output == True:
            voltage = voltage + self.hyst

        self.switching(voltage)                      #inherited from Comparator
        
class DelayOnTimer(Comparator):
    def __init__(self, setpoint, delay):
        Comparator.__init__(self, setpoint)               
        self.switch_level = setpoint
        self.delay = delay
        self.delay_output = False
               
    def trigger(self, voltage):
        self.switching(voltage)
        if self.output:
            print('Wait for {0:0.2f} seconds.'.format(self.delay))
            time.sleep(self.delay)
            self.delay_output = True
        else:
            self.delay_output = False