#!/usr/bin/env python3
# prog_04_02.py

class Comparator:                    
    def __init__(self, setpoint):
        self.switch_level = setpoint
        self.output = False
    
    def switching(self, voltage):
        if voltage > self.switch_level:
            self.output = True
        else:
            self.output = False         

class SchmittTrigger(Comparator):
    def __init__(self, setpoint, hysteresis):
        Comparator.__init__(self, setpoint)      #this is needed because the inherited __init__ has been
        self.hyst= hysteresis	                 #superceded by the preceding line.        
                
    def trigger(self, voltage):
        if self.output == True:
            voltage = voltage + self.hyst

        self.switching(voltage)                 #inherited from Comparator
            
trig1=SchmittTrigger(6, 2)   			        # on at 6 & off at 4

for v in (4.0,  4.5, 5.0, 5.5, 6.0, 6.5, 7.0, 6.5, 6.0, 5.5, 5.0, 4.5, 4.0):
    trig1.trigger(v)
    print('Input voltage = {0} -----Output = {1}'.format(v, trig1.output))
