#!/usr/bin/python3
#Prog 4-01
#arduino_slave_programming_tool_v1.0.py

from tkinter import  *
import os
import subprocess

def scan():
    listbox_usb.delete(0,END)
    acms = []
    file_list = os.listdir('/dev')
    for fl in file_list:
        if 'ACM' in fl or 'USB' in fl:
            listbox_usb.insert(END,fl)
    
def program():   
    index = listbox_usb.curselection()[0] 
    port = listbox_usb.get(index)
    p = subprocess.check_output(['avrdude', '-F', '-V', '-c', 'arduino', '-p', 'ATMEGA328P', '-P',\
        '/dev/{0:s}'.format(port), '-b', '115200', '-U', 'flash:w:slave.hex'],stderr=subprocess.STDOUT)
    text_output.insert(1.0, p)
    text_output.insert(1.0, 'USB Port {0:s}\n'.format(port))
    
root = Tk()
root.title('Slave Programming Tool')
listbox_usb = Listbox(root, selectmode ='single')
but_prog = Button(root, text = 'Program', command = program)
but_scan = Button(root, text = 'Scan', command = scan)
text_output = Text(root,width = 90)

but_scan.grid(row = 0, column = 0, padx =5, pady = 5, sticky = N)
but_prog.grid(row = 0, column = 1,padx = 5, pady = 5, sticky = N)
text_output.grid(row = 0, column = 2,padx = 5, pady = 5, sticky = N, rowspan = 2)
listbox_usb.grid(row = 1, column = 0,padx = 5, pady = 5, columnspan = 2)

root.mainloop()

