#!/usr/bin/env python3
#prog_05_02.py

import tkinter
import uno_slave
import time

class GuiDigOuts():
    def __init__(self, master):
        self.master = master
        self.uno1 = uno_slave.Uno(address = 1, project = 1, config_digital = [2,3,4,5,6,7,8,9])
        self.master.title('Write Digital Outputs - Timed Sequence')
        self.rate_scale = tkinter.Scale(master, orient = 'horizontal', length = 500, from_ =  1,
                                        to = 100, tickinterval = 10,label = 'Step Interval (ms)')   

        self.uno1.write_digital_dict = {2:0, 3:0, 4:0, 5:0, 6:0, 7:0, 8:0, 9:0,}
        self.step = 2
        self.direction = 1
        self.rate_scale.grid(row = 0, column = 0, padx = 10,pady = 10)
        self.drive()                

    def drive(self):
        self.uno1.write_digital_dict[self.step] = 0                
        if self.step == 9:
            self.direction = -1
        if self.step == 2:
            self.direction = 1
        
        self.step = self.step + self.direction               
        self.uno1.write_digital_dict[self.step] = 1
        self.uno1.write_digital()
        delay = self.rate_scale.get()
        delay = int(delay)   	 
      
        self.master.after(delay,self.drive)

tk = tkinter.Tk()
front_end = GuiDigOuts(tk)
tk.mainloop()
