#!/usr/bin/env python3
#prog_05_03.py

import tkinter
import uno_slave
import time

class GuiAnalogOuts():
    def __init__(self, master):
        self.master = master
        self.uno1 = uno_slave.Uno(address = 1, project = 1, config_digital = [])
        self.master.title('Write Analogue Outputs')
        self.scale_pin3 = tkinter.Scale(master, orient = 'vertical', length = 300, 
                            from_ = 255, to = 0, tickinterval = 50, label = 'Pin 3')        

        self.scale_pin5 = tkinter.Scale(master, orient = 'vertical', length = 300, 
                            from_ = 255, to = 0, tickinterval = 50, label = 'Pin 5')        

        self.scale_pin6 = tkinter.Scale(master, orient = 'vertical', length = 300, 
                            from_ = 255, to = 0, tickinterval = 50, label = 'Pin 6')        

        self.scale_pin9 = tkinter.Scale(master, orient = 'vertical', length = 300, 
                            from_ = 255, to = 0, tickinterval = 50, label = 'Pin 9')            
        
        self.scale_pin3.grid(row =0, column = 0, padx = 10,pady = 10)
        self.scale_pin5.grid(row =0, column = 1, padx = 10,pady = 10)
        self.scale_pin6.grid(row =0, column = 2, padx = 10,pady = 10)
        self.scale_pin9.grid(row =0, column = 3, padx = 10,pady = 10)

        self.drive()                

    def drive(self):
        self.uno1.write_analog_dict[3] = self.scale_pin3.get()
        self.uno1.write_analog_dict[5] = self.scale_pin5.get()
        self.uno1.write_analog_dict[6] = self.scale_pin6.get()
        self.uno1.write_analog_dict[9] = self.scale_pin9.get()
        self.uno1.write_analog()     
        self.master.after(100, self.drive)

tk = tkinter.Tk()
front_end = GuiAnalogOuts(tk)
tk.mainloop()
