#!/usr/bin/env python3
#prog_05_04.py

import tkinter
import uno_slave
import time

class GuiDigIns():
    def __init__(self, master):
        self.master = master
        self.uno1 = uno_slave.Uno(address = 1, project = 1, config_digital = [])
        self.master.title('Read Digital Inputs')
        self.can = tkinter.Canvas(master,width = 325, height = 125, bg = '#C0C0C0')
        self.pin_10_id = self.can.create_oval(25, 25, 75, 75, fill = 'red')
        self.pin_11_id = self.can.create_oval(100, 25, 150, 75, fill = 'red')
        self.pin_12_id = self.can.create_oval(175, 25, 225, 75, fill = 'red')
        self.pin_13_id = self.can.create_oval(250, 25, 300, 75, fill = 'red')
        self.can.create_text(50,100, text = 'Pin 10')
        self.can.create_text(125,100, text = 'Pin 11')
        self.can.create_text(200,100, text = 'Pin 12')
        self.can.create_text(275,100, text = 'Pin 13')   
        self.can.grid()
        self.drive()
                    
    def drive(self):
        self.uno1.read_digital()

        if self.uno1.read_digital_dict[10]:
            self.can.itemconfigure(self.pin_10_id, fill = 'green')
        else:
            self.can.itemconfigure(self.pin_10_id, fill = 'red')

        if self.uno1.read_digital_dict[11]:
            self.can.itemconfigure(self.pin_11_id, fill = 'green')
        else:
            self.can.itemconfigure(self.pin_11_id, fill = 'red')

        if self.uno1.read_digital_dict[12]:
            self.can.itemconfigure(self.pin_12_id, fill = 'green')
        else:
            self.can.itemconfigure(self.pin_12_id, fill = 'red')

        if self.uno1.read_digital_dict[13]:
            self.can.itemconfigure(self.pin_13_id, fill = 'green')
        else:
            self.can.itemconfigure(self.pin_13_id, fill = 'red')
        
        self.master.after(100, self.drive)

tk = tkinter.Tk()
front_end = GuiDigIns(tk)
tk.mainloop()
