#!/usr/bin/env python3
#prog_05_05.py

import tkinter
import uno_slave
import time

class GuiAnalogIns():
    def __init__(self, master):
        self.master = master
        self.uno1 = uno_slave.Uno(address = 1, project = 2, config_digital = [9])
        self.master.title('Read Analog Inputs')
        self.btn_off = tkinter.Button(master, text = 'Off', command = self.off)
        self.btn_on = tkinter.Button(master, text = 'On', command = self.on)
        self.lbl_A0 = tkinter.Label(master, text = 'Input A0 0.00V')          
        self.lbl_A1 = tkinter.Label(master, text = 'Input A1 0.00V')

        self.lbl_A0.grid(row = 0, column = 0, columnspan = 2, padx = 10, pady = 10)
        self.lbl_A1.grid(row = 1, column = 0, columnspan = 2, padx = 10, pady = 10)
        self.btn_off.grid(row = 2, column = 0, padx = 10, pady = 10)
        self.btn_on.grid(row = 2, column = 1, padx = 10, pady = 10)
        self.master.columnconfigure(0, weight = 1, minsize = 150)
        self.master.columnconfigure(1, weight = 1, minsize = 150)        
        self.drive()
                
    def drive(self):
        self.uno1.read_analog(2)
        v0 = self.uno1.read_analog_dict[0]
        v0 = 5*v0/1023
        v1 = self.uno1.read_analog_dict[1]
        v1 = 5*v1/1023

        self.lbl_A0.configure(text = 'Input A0 {0:0.2f} Volts'.format(v0))
        self.lbl_A1.configure(text = 'Input A1 {0:0.2f} Volts'.format(v1))        
        self.master.after(100, self.drive)

    def off(self):
        self.uno1.write_digital_dict[9] = 0
        self.uno1.write_digital()

    def on(self):
        self.uno1.write_digital_dict[9] = 1
        self.uno1.write_digital()

tk = tkinter.Tk()
front_end = GuiAnalogIns(tk)
tk.mainloop()
