#!/usr/bin/env python3
#prog_06_02.py

import tkinter
import uno_slave
import plotter 

class GuiAnalogIns(tkinter.Frame):
    def __init__(self, master):
        self.master = master
        self.uno1 = uno_slave.Uno(address = 1, project = 2, config_digital = [9])
        self.master.title('CR Charge/Discharge')
        self.Y = 800
        self.X = 1600

        # 5V max for the Y axis, 80 seconds for the X (800 pixels wide plotterotting every 100ms)
        self.graph1 = plotter.Graph(master,self.X, self.Y, scale_x = self.X/10,  scale_y = 5)    
        self.btn_on = tkinter.Button(master,text = 'Charge', command = self.on)
        self.btn_off = tkinter.Button(master,text = 'Discharge', command = self.off)
        self.v_max = 0

        self.graph1.frm.grid(row = 0, column = 0, padx = 10, pady =10,columnspan = 2)   
        self.btn_off.grid(row = 1, column = 0, pady = 10)
        self.btn_on.grid(row = 1, column = 1, pady = 10)         
        self.graph1.reset()                     
        self.drive()
                
    def drive(self):
        self.uno1.read_analog(2)
        v = self.uno1.read_analog_dict[0]
        y0 = self.Y*v/1023
        v = self.uno1.read_analog_dict[1]
        y1 = self.Y*v/1023
        if y1 > self.Y/2:
            self.v_max = y1
        
        self.graph1.plot(y0, y1, self.v_max * 0.6321, self.v_max * 0.3679)  
        self.master.after(100, self.drive)

    def off(self):
        self.uno1.write_digital_dict[9] = 0
        self.uno1.write_digital()

    def on(self):
        self.uno1.write_digital_dict[9] = 1
        self.uno1.write_digital()
        
tk = tkinter.Tk()
front_end = GuiAnalogIns(tk)
tk.mainloop()