#!/usr/bin/env python3
#prog_07_03.py

X = 800
Y = 600
template_file = open("template_07_02.bmp",'rb')
byte_s = template_file.read()
template_file.close()
header = byte_s[0:54]
bit_map = byte_s[54:]
bit_map_dict = {}

for y in range (0, Y):
    for x in range (0, X):
        key = (x, y)
        pixel_list = []
        for c in range (0, 3):
            t = bit_map[3 * (y * X + x) + c]
            pixel_list.append(t)
            bit_map_dict[key] = pixel_list

out_byte_a = bytearray(header)				   # Starts the output bytearray with the header.

for y in range (0,Y):
    for x in range (0,X):
        key = (x,y)
        for c in range (0, 3):
            colour = bit_map_dict[key][c]		# Takes each pixels colour byte one at a time.
            colour_byte = bytes([colour])       # colour is an int and has to be put in an iterable type and converted to bytes.
            out_byte_a.extend(colour_byte)		# Output bytearray is extended by the next colour byte.	
       
output_file = open("output.bmp", 'wb')
output_file.write(out_byte_a)
output_file.close()
