#!/usr/bin/env python3
#prog_07_04.py

import math			

X = 800
Y = 600
template_file = open("template_07_02.bmp", 'rb')
byte_s = template_file.read()
template_file.close()
header = byte_s[0:54]
bit_map = byte_s[54:]
bit_map_dict = {}

for y in range (0, Y):
    for x in range (0, X):
        key=(x, y)
        pixel_list = []
        for c in range (0, 3):
            t = bit_map[3 * (y * X + x) + c]
            pixel_list.append(t)
            bit_map_dict[key] = pixel_list

for x in range(0, X):                        #This loop adds the sine wave to the graph
    x_rad = math.radians(x * 360.0/X)
    y = int(0.5*Y + 0.5*Y*math.sin(x_rad))
    bit_map_dict[(x, y)] = [0,0,255]

out_byte_a = bytearray(header)

for y in range (0, Y):
    for x in range (0, X):
        key=(x, y)
        for c in range (0, 3):
            colour = bit_map_dict[key][c]		
            colour_byte = bytes([colour])        
            out_byte_a.extend(colour_byte)		
       
output_file = open("output.bmp", 'wb')
output_file.write(out_byte_a)
output_file.close()
