#!/usr/bin/env python3
#prog_09_04.py
import cherrypy

class SvgDemo:
    @cherrypy.expose
    def index(self,orientation="LR"):
        if orientation == "LR":
            y1 = 0
            y2 = 500
        else:
            y1 = 500
            y2 = 0

        return '''
<!DOCTYPE html>
<html>
<body>
<h3>Lines Using Scaleable Vector Graphics</h3>
<svg height="500" width="720">
<line x1="360" y1="0" x2="360" y2="500" style="stroke:rgb(0,255,0);stroke-width:2" /> <!-- vertical line -->
<line x1="0" y1="250" x2="720" y2="250" style="stroke:rgb(0,255,0);stroke-width:2" /> <!-- horizontal line -->
<line x1="0" y1="{0:d}" x2="720" y2="{1:d}" style="stroke:rgb(255,0,0);stroke-width:2" />   <!-- diagonal -->    
</svg>
<form action = "index" method = "get">
<input type = "submit" value = "SEND"  </input>&nbsp
<input type = "radio" name = "orientation" value = "RL" >Top Right to Bottom Left</input>&nbsp
<input type = "radio" name = "orientation" value = "LR" checked>Top Left to Bottom Right</input>
</body></html> '''.format(y1,y2)


cherrypy.config.update({'server.socket_host': '0.0.0.0',
                        'log.access_file':'server_access.log',
                        'log.error_file':'server_error.log'})
cherrypy.quickstart(SvgDemo())


