#!/usr/bin/env python3
#prog_09_06.py
import pickle
import math
import cherrypy

class WebCurrentMonitor:
    @cherrypy.expose
    def index(self):
        return """<!DOCTYPE html>
    <html>
    <body>
    <h3>Current Monitor</h3>
    <a href = "/trend">Trend</a><br><br><a href = "/ammeter">Ammeter</a>
     
    </body></html>"""

    @cherrypy.expose
    def trend(self, history=0):
        history = int(history)
        #trend_list = []
        with open('/dev/shm/trend_data.dat', 'rb') as f:
            trend_list = pickle.load(f)

        with open('/dev/shm/ammeter_data.dat', 'rb') as f:
            ammeter_list = pickle.load(f)
               
        trend_list = trend_list[-720*history - 720:]
        if history == 0:
            meta = '<meta http-equiv="refresh" content="60">'
            history_stamp = 'Live'
        else:
            meta = ''
            history_stamp = 'Plot at -{0:d} Hours'.format(history*2)

        s = ('''<!DOCTYPE html>
        <html>''')
        s = s + '{0:s}'.format(meta)
        s = s + '''<body>
            <h3>Trend - {0:s}</h3>
            <svg height="500" width="720">'''.format(history_stamp)

        for n in range (0, 501, 50):
            s = s + '''<line x1="0" y1="{0:d}" x2="720" y2="{0:d}" style="stroke:rgb(0,255,0);stroke-width:1" />\n'''.format(n)

        for n in range (0, 721, 90):
            w = 1
            if n%180 == 0:
                w = 2
            s = s + ('''<line x1="{0:d}" y1="0" x2="{0:d}" y2="500" style="stroke:rgb(0,255,0);stroke-width:{1:d}" />\n'''
                .format(n, w)) 

        for point in range (1, 720):
            s = s + ('''<line x1="{0:d}" y1="{1:d}" x2="{2:d}" y2="{3:d}" style="stroke:rgb(255,0,0);stroke-width:1" />\n'''
                    .format(point -1 , trend_list[point - 1], point, trend_list[point]))

        s = s + '</svg><br>'
        s = s + '''Hor. Scale = 15 Mins/Div.  Vert. Scale = {0:0.1f} Amps/Div.<br><br>'''.format(ammeter_list[0]/10)
        s = s + '''<form action = "/trend" method = "get">
        <input type = "radio" name = "history" value = "0" checked >LIVE</input>
        <input type = "radio" name = "history" value = "1">-2</input>&nbsp
        <input type = "radio" name = "history" value = "2">-4</input>&nbsp
        <input type = "radio" name = "history" value = "3">-6</input>&nbsp
        <input type = "radio" name = "history" value = "4">-8</input>&nbsp
        <input type = "radio" name = "history" value = "5">-10</input>&nbsp
        <input type = "radio" name = "history" value = "6">-12</input><br><br>
        <input type = "radio" name = "history" value = "7">-14</input>&nbsp
        <input type = "radio" name = "history" value = "8">-16</input>&nbsp
        <input type = "radio" name = "history" value = "9">-18</input>&nbsp
        <input type = "radio" name = "history" value = "10">-20</input>&nbsp
        <input type = "radio" name = "history" value = "11">-22</input>&nbsp
        <input type = "submit" value = "SEND"  </input><br><br>
        <a href = "index">Home</a><br><br><a href = "ammeter">Ammeter</a>
        </body>
        </html>'''
        return s
                
    @cherrypy.expose
    def ammeter(self):
        with open('/dev/shm/ammeter_data.dat', 'rb') as f:
            ammeter_list = pickle.load(f)

        s = '''<!DOCTYPE html>
            <html>
            <meta http-equiv="refresh" content="10">
            <body>
            <h3>Ammeter</h3>
            <svg height="555" width="555">'''

        s = s + '''<line x1="0" y1="0" x2="550" y2="0" style="stroke:rgb(0,0,255);stroke-width:4" />\n'''
        s = s + '''<line x1="550" y1="0" x2="550" y2="550" style="stroke:rgb(0,0,255);stroke-width:4" />\n'''
        s = s + '''<line x1="550" y1="550" x2="0" y2="550" style="stroke:rgb(0,0,255);stroke-width:4" />\n'''
        s = s + '''<line x1="0" y1="550" x2="0" y2="0" style="stroke:rgb(0,0,255);stroke-width:4" />\n'''
        R1 = 450
        R2 = 500
        for graduation in range (0, 101, 10):
            alpha = math.radians(graduation*90/100)  
            x2 = 500 - int(R2*math.cos(alpha))
            y2 = 500 - int(R2*math.sin(alpha))
            x1 = 500 - int(R1*math.cos(alpha))
            y1 = 500 - int(R1*math.sin(alpha))

            s = s + '''<line x1="{0:d}" y1="{1:d}" x2="{2:d}" y2="{3:d}" '''.format(x1 ,y1 , x2, y2)
            s = s +  '''style="stroke:rgb(0,0,255);stroke-width:2" />\n'''
           
        
        alpha = math.radians(ammeter_list[1]*90/ammeter_list[0])
        w = 20
        xp = 500 - int(R1*math.cos(alpha))
        yp = 500 - int(R1*math.sin(alpha))
        xa = 500 + int(math.sin(alpha)*w)
        ya = 500 - int(math.cos(alpha)*w)
        xb = 500 - int(math.sin(alpha)*w)
        yb = 500 + int(math.cos(alpha)*w)
        s = s + '''<polygon points = "{0:d},{1:d},{2:d},{3:d},{4:d},{5:d}" '''.format(xp, yp, xa, ya, xb, yb)
        s = s + ''' style="fill:rgb(255,0,0);stroke:rgb(0,0,255);stroke-width:2" />\n'''      
        s = s + '''<text x="10" y="50" style="fill:rgb(255,0,0);font-size:40px" >{0:0.1f} Amps</text>'''.format(ammeter_list[1])
        s = s + ''' </svg> <br />
        <br><a href = "index">Home</a><br><br><a href = "/trend">Trend</a>
        </body>
        </html> '''            
        return s

if __name__ == '__main__':
    cherrypy.config.update({'server.socket_host': '0.0.0.0',
                            'log.access_file':'server_access.log',
                            'log.error_file':'server_error.log'})
    cherrypy.quickstart(WebCurrentMonitor())
