#!/usr/bin/env python3
#prog_10_09.py

import curses

class IndicatorLamp:
    def __init__(self, std_scr, start_y = 0, start_x = 0, captions = ['   ', '   '], colorpair_off = 1, colorpair_on = 2):
        self.stdscr = std_scr
        width = len(max(captions, key = len)) + 2 
        self.x_dict = {0:width//2 - len(captions[0])//2, 1:width//2 - len(captions[1])//2}
        self.captions = captions
        self.colorpair_off = colorpair_off
        self.colorpair_on  = colorpair_on      
        self.win = curses.newwin(3, width, start_y, start_x)
        self.set_state(False)        

    def set_state(self, state):
        self.win.clear()
        if state:
            self.win.bkgd(' ', curses.color_pair(self.colorpair_on))
        else:            
            self.win.bkgd(' ', curses.color_pair(self.colorpair_off))

        self.win.addstr(1, self.x_dict[int(state)], self.captions[int(state)], curses.A_BOLD)

if __name__ == '__main__':
    def main(stdscr):
        curses.init_pair(1, curses.COLOR_WHITE, curses.COLOR_RED)
        curses.init_pair(2, curses.COLOR_WHITE, curses.COLOR_GREEN)
        curses.init_pair(3, curses.COLOR_WHITE, curses.COLOR_YELLOW)
        curses.curs_set(0)
        lamp1 = IndicatorLamp(stdscr, start_y = 2, start_x = 2, captions = ['Stationary', 'Moving'])
        lamp2 = IndicatorLamp(stdscr, start_y = 7, start_x = 2, captions = ['Stopped', 'Started'], colorpair_on = 3)
        stdscr.refresh()
        lamp1.win.refresh()
        lamp2.win.refresh()
        stdscr.getch()

        lamp1.set_state(1)
        lamp2.set_state(1)
        stdscr.refresh()
        lamp1.win.refresh()
        lamp2.win.refresh()
        stdscr.getch()

        lamp1.set_state(0)
        lamp2.set_state(0)            
        stdscr.refresh()
        lamp1.win.refresh()
        lamp2.win.refresh()
        stdscr.getch()
        
    curses.wrapper(main)
    