#!/usr/bin/env python3
#prog_10_10.py

import curses

class AnalogGauge:
    def __init__(self, std_scr, start_y = 0, start_x = 0, fullscale = 1, units = 'Units', colorpair = 0):
        self.stdscr = std_scr        
        self.scale = fullscale
        self.win = curses.newwin(5, 102, start_y, start_x)
        self.win.bkgd(' ', curses.color_pair(colorpair) | curses.A_BOLD)
        for n in range (0, 101):
            if n %10 == 0:
                self.win.addstr(1,  n, "|")

        self.win.addstr(1, 3, units)
        self.win.box()
        self.drive(0)        

    def drive(self, value):
        deflection = 100*value/self.scale
        if deflection >  100:
            deflection = 100.0     
        
        self.win.addstr(3, 3, '{0:06.2f}'.format(value))
        self.win.clrtoeol() 
        deflection = int(deflection)
        self.win.addstr(2 , 1, '|'*deflection)
        self.win.clrtoeol()
        self.win.box()

if __name__ == '__main__':
   
    def main(stdscr):
        curses.curs_set(0)
        gauge1 = AnalogGauge(stdscr, start_y =10, start_x = 10, fullscale = 100, units = 'Volts')
        stdscr.refresh()
        gauge1.win.refresh()
        for n in range (0,1001):
            gauge1.drive(n/10.1)
            stdscr.refresh()
            gauge1.win.refresh()
            curses.napms(10)

        for n in range (0,101):
            gauge1.drive(100 - n)
            stdscr.refresh()
            gauge1.win.refresh()
            curses.napms(30)

        gauge1.drive(80)
        stdscr.refresh()
        gauge1.win.refresh()
        stdscr.getch() 

    curses.wrapper(main)
