#!/usr/bin/env python3
#prog_10_14.py

import curses

class Button:  
    def __init__(self, std_scr, start_y = 0, start_x = 0, caption = 'Button', colorpair = 0):
        curses.mousemask(curses.BUTTON1_PRESSED)
        self.stdscr = std_scr        
        self.start_x = start_x
        self.start_y = start_y 
        self.width = len(caption) + 2
        self.win = curses.newwin(3, self.width, start_y , start_x)
        self.win.bkgd(' ', curses.color_pair(colorpair) | curses.A_BOLD)
        self.win.box()
        self.win.addstr(1, 1, caption)
        self.state = False
        self.stdscr.refresh()
        self.win.refresh()

    def poll(self, mouseevent):
        _, x, y, _, event_type = mouseevent
        if event_type == curses.BUTTON1_PRESSED:
            x = x - self.start_x
            y = y - self.start_y
 
        if x > 0 and x < self.width and    y >= 0 and y <= 2:
            self.state = True  

if __name__ == '__main__':   
    def main(stdscr):
        curses.init_pair(1, curses.COLOR_WHITE, curses.COLOR_CYAN)
        curses.init_pair(2, curses.COLOR_WHITE, curses.COLOR_GREEN)
        curses.curs_set(0)
        stdscr.timeout(0)
        button1 = Button(stdscr, start_y = 10, start_x = 10, caption = 'ON ', colorpair = 1)
        button2 =  Button(stdscr, start_y = 10, start_x = 20, caption = 'OFF', colorpair = 2)
        output = False
        while True:
            event = stdscr.getch()
            if event == curses.KEY_MOUSE:
                mouse_event = curses.getmouse()     
                button1.poll(mouse_event)
                button2.poll(mouse_event)
            if event == ord('q'):
                break
                                    
            if button1.state:         
                button1.state = False
                output = True            

            if button2.state:         
                button2.state = False
                output = False           
                 
            stdscr.addstr(14, 10, '{0:s}'.format(str(output)), curses.A_BOLD)
            stdscr.clrtoeol()
            stdscr.refresh()
            curses.napms(10)
            
    curses.wrapper(main)
