#!/usr/bin/env python3
#prog_10_16.py

import curses
import curses_widgets
import uno_slave

def main(stdscr):
    curses.init_pair(1, curses.COLOR_WHITE, curses.COLOR_RED)
    curses.init_pair(2, curses.COLOR_WHITE, curses.COLOR_GREEN)
    curses.curs_set(0)
    stdscr.timeout(0)
    curses.mousemask(curses.BUTTON1_PRESSED)    
    uno1 = uno_slave.Uno(address = 1, project = 5, config_digital = [10, 11, 12, 13])
    meterA0 = curses_widgets.AnalogGauge(stdscr, start_y = 5, start_x = 5, fullscale = 5.0, units = 'A0 Volts') 
    meterA1 = curses_widgets.AnalogGauge(stdscr, start_y = 10, start_x = 5, fullscale = 5.0, units = 'A1 Volts') 
    meterA2 = curses_widgets.AnalogGauge(stdscr, start_y = 15, start_x = 5, fullscale = 5.0, units = 'A2 Volts') 
    meterA3 = curses_widgets.AnalogGauge(stdscr, start_y = 20, start_x = 5, fullscale = 5.0, units = 'A3 Volts') 
    meterA4 = curses_widgets.AnalogGauge(stdscr, start_y = 25, start_x = 5, fullscale = 5.0, units = 'A4 Volts') 
    lamp2 = curses_widgets.IndicatorLamp(stdscr, start_y = 30, start_x = 5, captions = ['Pin2 Low','Pin2 High'])
    lamp3 = curses_widgets.IndicatorLamp(stdscr, start_y = 30, start_x = 17, captions = ['Pin3 Low','Pin3 High'])
    lamp4 = curses_widgets.IndicatorLamp(stdscr, start_y = 30, start_x = 29,  captions = ['Pin4 Low','Pin4 High'])
    lamp5 = curses_widgets.IndicatorLamp(stdscr, start_y = 30, start_x = 41,  captions = ['Pin5 Low','Pin5 High'])
    lamp6 = curses_widgets.IndicatorLamp(stdscr, start_y = 30, start_x = 53,  captions = ['Pin6 Low','Pin6 High'])
    lamp7 = curses_widgets.IndicatorLamp(stdscr, start_y = 30, start_x = 65,  captions = ['Pin7 Low','Pin7 High'])
    lamp8 = curses_widgets.IndicatorLamp(stdscr, start_y = 30, start_x = 77,  captions = ['Pin8 Low','Pin8 High'])
    button10 = curses_widgets.Button(stdscr, start_y = 33, start_x = 5, caption = 'Pin10 Out')     
    button11 = curses_widgets.Button(stdscr, start_y = 33, start_x = 16, caption = 'Pin11 Out')     
    button12 = curses_widgets.Button(stdscr, start_y = 33, start_x = 27, caption = 'Pin12 Out')     
    button13 = curses_widgets.Button(stdscr, start_y = 33, start_x = 38, caption = 'Pin13 Out')
    twheel1 = curses_widgets.ThumbWheel(stdscr, start_y = 33, start_x = 49)     
    output10 = False
    output11 = False
    output12 = False
    output13 = False

    while 1:
        event = stdscr.getch()
        if event == curses.KEY_MOUSE:
            try:
                mouse_event = curses.getmouse()
                button10.poll(mouse_event)
                button11.poll(mouse_event)
                button12.poll(mouse_event)
                button13.poll(mouse_event)
                twheel1.poll(mouse_event)
            except Exception as e:
                with open('error.txt', 'a') as f:
                    f.write(str(e) + '\n')

        if event == ord('q'):
            break        
# Reset the buttons' state after being clicked and toggle the output variables
        if button10.state:
            button10.state = False
            output10 = output10 ^ True
        if button11.state:
            button11.state = False
            output11 = output11 ^ True
        if button12.state:
            button12.state = False
            output12 = output12 ^ True
        if button13.state:
            button13.state = False
            output13 = output13 ^ True     
        
# Read Digital Inputs and drive lamps
        uno1.read_digital()
        lamp2.set_state(uno1.read_digital_dict[2])      
        lamp3.set_state(uno1.read_digital_dict[3])      
        lamp4.set_state(uno1.read_digital_dict[4])      
        lamp5.set_state(uno1.read_digital_dict[5])      
        lamp6.set_state(uno1.read_digital_dict[6])      
        lamp7.set_state(uno1.read_digital_dict[7])
        lamp8.set_state(uno1.read_digital_dict[8])           
         
# Read Analog Inputs and drive meters
        uno1.read_analog(5)
        meterA0.drive(5*uno1.read_analog_dict[0]/1023)
        meterA1.drive(5*uno1.read_analog_dict[1]/1023)
        meterA2.drive(5*uno1.read_analog_dict[2]/1023)
        meterA3.drive(5*uno1.read_analog_dict[3]/1023)
        meterA4.drive(5*uno1.read_analog_dict[4]/1023)

# Write Digital Outputs
        uno1.write_digital_dict[10] = output10 
        uno1.write_digital_dict[11] = output11
        uno1.write_digital_dict[12] = output12 
        uno1.write_digital_dict[13] = output13 
        uno1.write_digital()

# Write Anaolog Output
        aout =  int(twheel1.value*255/5)
        if aout > 255:
            aout = 255
        if aout < 0:
            aout = 0
        #stdscr.addstr(1, 10, str(aout))
        #stdscr.clrtoeol()      
        uno1.write_analog_dict[9] = aout
        uno1.write_analog()
        
# Refresh screen and windows        
        stdscr.refresh()
        meterA0.win.noutrefresh()
        meterA1.win.noutrefresh()
        meterA2.win.noutrefresh()
        meterA3.win.noutrefresh()
        meterA4.win.noutrefresh()
        lamp2.win.noutrefresh()
        lamp3.win.noutrefresh()
        lamp4.win.noutrefresh()
        lamp5.win.noutrefresh()
        lamp6.win.noutrefresh()
        lamp7.win.noutrefresh()
        lamp8.win.noutrefresh()
        button10.win.noutrefresh() 
        button11.win.noutrefresh() 
        button12.win.noutrefresh() 
        button13.win.noutrefresh()
        twheel1.win.noutrefresh() 
        curses.doupdate()
        #curses.napms(50)

curses.wrapper(main)
