list     p=12f1822
#include <p12f1822.inc>



    __config  0x8007, (_FOSC_INTOSC & _WDTE_OFF & _PWRTE_OFF & _MCLRE_OFF & _CP_OFF & _BOREN_OFF & _IESO_OFF & _FCMEN_OFF )
    __config  0x8008, (_LVP_ON & _PLLEN_OFF)

    cblock 0x70


Ip                    ;peak current
buffer_i
sample_counter
inner_counter

    endc
     
    org 0x00
    goto start

    org 0x04
    btfss INTCON, TMR0IF ; TMR0 overflows every 1.024ms 18.4 degrees of 50Hz, sin(81degrees) = 0.987
    retfie
    goto ISR_TMR0


    org 0x08    
    
start:
;----------initialise
    movlb   1 ; and OSCCON and ADRESL/H and ADCON0/1

    movlw   b'01110000' ; 8Mhz
    movwf   OSCCON        

    movlw   b'00000001'
    movwf    ADCON0

    movlw   b'01010000'
    movwf    ADCON1
   
    movlw   b'10000111'
    movwf   OPTION_REG

    movlw b'11100000'
    movwf INTCON
    

    movlb 1
    movlw b'00000100'
    movwf OPTION_REG
    bsf TRISA, 2 
    bsf TRISA, 0

    movlb 0
    movlw 0x65
    movwf PR2


    movlb 5
    movlw b'00001100'
    movwf CCP1CON

    

    movlb 0
    bcf PIR1, TMR2IF  

    movlw b'00000110'
    movwf T2CON

    movlb 1
    bcf TRISA, 2    
    ;---------------end of initialisation
    
Samples:   
    
    movlb 1   
    bsf     ADCON0, ADGO ;Start conversion
    btfsc   ADCON0, ADGO
    goto    $-1
    movf    Ip, w        ;stored peak in working
    subwf   ADRESH, w    ;subtract stored peak from instantaneous, update if result is positive  
    btfsc   STATUS, C    ;C = 0 when result is positive
    goto    update_peak  ; high order instantaneous > stored, update stored
    goto Update_pww
    
update_peak:
    movfw ADRESH
    movwf Ip
   
Update_pww:                  
    movlb 5      
    movfw Ip
    movwf buffer_i
    lsrf buffer_i, f
    lsrf buffer_i, f
    movlw d'18'
    addwf buffer_i, w    
    movwf CCPR1L
    goto Samples


ISR_TMR0: 
    decf sample_counter, f
    btfsc STATUS, Z
    clrf Ip

  
    bcf INTCON, TMR0IF
    retfie
          
    end 



